#include <qapplication.h>

#include <command_set.hh>
#include <qtlook/look.hh>

struct perform_cmd
{
	perform_cmd(command_set& c):
	    c_(c),
	    r_(true)
	{}

	void operator()(const command& cmd)
	{
		if(!r_) return;
		r_ = process_cmd(cmd,c_);
	}

	operator bool() const { return r_; }
private:
	command_set& c_;
	bool r_;
};

bool process_cmd_set(long idx,command_set& cmds)
{
    if (idx < 0) return true; //ingnore nonexistent commands

    std::cerr<<"processing cmd set #"<<idx<<std::endl;
    command_set c = cmds;//made a copy of current command set
    return c.for_each(idx, perform_cmd(cmds));
}

mapper *qtlook_mapper = 0;

int main(int argc,char *argv[])
{
    QApplication app(argc,argv);
    scm::init();
    scm::load(scm::commondir + "mapper.scm");

    dialog_ptr& dia = qtlook_dialog::instance();
    command_set cmds;
    evaluator &eval = qtlook_eval::instance();
    eval.functab_["lookup"] = qtlook_lookup;
    eval.functab_["enlist"] = qtlook_enlist;
    eval.functab_["cat"] = qtlook_cat;

    //qtlook_mapper = new xml_mapper("testmap.xml");
    qtlook_mapper = new scm_mapper("testmap.scm");
    long idx = cmds.add(command("/ctrl/look")("action", "view")("id", "/"));
    while(process_cmd_set(idx,cmds))
    {
	if (dia.get())  idx = dia->run();
    }

    dia = 0;

    std::cout<<"xx"<<std::endl;//stop bus

    return 0;
}
